
/**
 * Clase que representa un Cliente del Sistema de Facturacion
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class Cliente
{
    // ATRIBUTOS de la clase Cliente
    private int idc;
    private String descr;
    private double saldo;

    // CONSTRUCTORES
    /**
     * Constructor para crear objetos de la clase Cliente
     */
    public Cliente()
    {
        this(1);
    }
    /**
     * Constructor para crear objetos de la clase Cliente
     * @param codigo Codigo de cliente
     */
    public Cliente(int codigo) {
        this(codigo,"Sin Nombre");
    }
    /**
     * Constructor para crear objetos de la clase Cliente
     * @param codigo Codigo de cliente
     * @param nombre Nombre de cliente
     */
    public Cliente(int codigo,String nombre) {
        this(codigo,nombre,0.0);
    }
    /**
     * Constructor para crear objetos de la clase Cliente
     * @param codigo Codigo de cliente
     * @param nombre Nombre de cliente
     * @param saldo Saldo del cliente
     */
    public Cliente(int codigo,String nombre,double saldo) {
        setIdc(codigo);
        setDescr(nombre);
        setSaldo(saldo);
    }
        
    
    //METODOS GETTERS
    /**
     * Obtengo el codigo de cliente
     * @return devuelve el codigo de cliente
     */
    public int getIdc() { 
        return idc;
    }
    /**
     * @return devuelve la razon social del cliente
     */
    public String getDescr() {
        return descr;
    }
    public double getSaldo() {
        return saldo;
    }
    
    //METODOS SETTERS
    /**
     * Cambia el codigo de Cliente
     * @param codigo codigo de cliente
     */
    public void setIdc(int idc) {
        this.idc = idc;
    }
    public void setDescr(String nombre) {
        descr = nombre;
    }
    public void setSaldo(double monto) {
        saldo = monto;
    }
    public Cliente agregarSaldo(double monto) {
        saldo += monto;
        return this;
    }

}
