import java.util.*;
/**
 * Clase que representa una Factura del Sistema de Facturacion
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class Factura {
    // ATRIBUTOS
    private int nro;
    private Date fecha;
    private Cliente cliente     = null;
    private boolean confirmada  = false;
    private double monto        = 0.0;
    private boolean pagada      = false;
    private Detalle detalle[]   = new Detalle[20];
    private int cnt             = 0;

    // CONSTRUCTORES
    /**
     * Constructor para crear objetos de la clase Factura
     */
    public Factura() {
        this(1); // asumo que el nro de la factura es 1
    }
    public Factura(int n) {
        this(n,new Date());
    }
    public Factura(int n,Date f) {
        this(n,f,new Cliente());
    }
    public Factura(int n,Date f,Cliente c) {
        setNro(n);
        setFecha(f);
        setCliente(c);
    }
    
    // GETTERS
    public int getNro()             { return nro;   }
    public Date getFecha()          { return fecha; }
    // fecha en formato dd/mm/yyyy
    public String getFechaStr()     { return null; } // ??
    public Cliente getCliente()     { return cliente; }
    public int getCount()           { return cnt; }
    public boolean isConfirmada()   { return confirmada; }
    public boolean isPagada()       { return pagada; }
    public double getMonto()        { return monto; }
    
    // SETTERS
    public void setNro(int n)           { nro = n; }
    public void setFecha(Date d)        { fecha = d; }
    public void setFecha(String d)      {  } // ????
    public void setCliente(Cliente c)   { cliente = c; }
    
    // CUSTOM
    public void confirmar()                 {} //??
    public void pagar()                     {} // ??
    private void calcular()                 {} // ??
    public void addDetalle(Detalle d)       {
        if ( !isConfirmada() ) {
            // puedo agregar detalle
            if ( getCount() < detalle.length ) {
                // hay lugar para el nuevo detalle
                for(int i=0;i < detalle.length; i++) {
                    if ( detalle[i] == null ) {
                        // encontre un lugar vacio para poner la referencia a este objeto Detalle
                        detalle[i] = d;
                        cnt++;
                        break;
                    }
                }
            } else {
                System.err.println("addDetalle(): Error, Factura llena!");
            }
        } else {
            System.err.println("addDetalle(): Error, factura confirmada!");
        }
    } // ??
    public void addDetalle(Detalle d,int p) {
        if ( p >= 0 && p < detalle.length ) {
            if ( !isConfirmada() ) {
                // puedo agregar detalle
                if ( getCount() < detalle.length ) {
                    // hay lugar para el nuevo detalle
                    if ( detalle[p] == null ) {
                        detalle[p] = d;
                        cnt++;
                    } else { // esta posicion ya estaba ocupada por otro objeto Detalle
                        detalle[p] = d;
                    }
                } else {
                    System.err.println("addDetalle(): Error, Factura llena!");
                }
            } else {
                System.err.println("addDetalle(): Error, factura confirmada!");
            }
        } else {
            System.err.println("addDetalle(): Error, posicion incorrecta!");
        }
    } // ??
    public void delDetalle(Detalle d)       {} // ??
    public void delDetalle(int p)           {} // ??
}
